local BEAMNG = {}

local helper = require('scenario/scenariohelper')

local slowSpeed = false
local highSpeedA = false
local highSpeedB = false
local highSpeedC = false
local madeIt = false
local vehicle = nil
local explode1 = nil
local explode2 = nil
local explode = false
local trigger8 = false


--core_environment.setTimeOfDay({time=1.0, play=false})



local function reset()
  slowSpeed = false
  highSpeedA = false
  highSpeedB = false
  highSpeedC = false
  madeIt = false
  vehicle = nil
  explode = false  
  explode1 = false
  explode2 = false
  trigger8 = false  
end



local function onRaceStart()
  reset()

  helper.queueLuaCommandByName('sheriff', 'electrics.set_lightbar_signal(1)')
  helper.queueLuaCommandByName('sheriff', 'electrics.set_warn_signal(1)')
  helper.queueLuaCommandByName('sheriff', 'electrics.setLightsState(2)')
  helper.queueLuaCommandByName('tow', 'electrics.setLightsState(2)')
  --helper.queueLuaCommandByName('tow', 'powertrain.toggleDefaultDiffs()')
  helper.queueLuaCommandByName('tow', 'beamstate.toggleCouplers()')  
  helper.queueLuaCommandByName('trailer', 'beamstate.toggleCouplers()')  
    
  vehicle = helper.getVehicleByName('load1')
  explode1 = helper.getVehicleByName('exp1') 
  explode2 = helper.getVehicleByName('exp2')
  
  
  helper.queueLuaCommand(explode1, 'fire.igniteVehicle()') 
  helper.queueLuaCommand(explode2, 'fire.igniteVehicle()')

end


local function getVehicleSpeed()
	local playerData = map.objects[map.objectNames['tow']]
	local ms = playerData.vel:length()

	--print("ms "..ms)
	return ms
end


local function onBeamNGTrigger(data)
  local luaTrigger = data.triggerName

  if luaTrigger == 'explode1' then
  helper.queueLuaCommand(explode1, 'fire.explodeVehicle()') 
  helper.queueLuaCommand(explode2, 'fire.explodeVehicle()')
  
  elseif luaTrigger == 'explode2' then
  helper.queueLuaCommand(explode1, 'fire.explodeVehicle()') 
  helper.queueLuaCommand(explode2, 'fire.explodeVehicle()')

  elseif luaTrigger == 'explode3' or luaTrigger == 'explode4' then
  helper.queueLuaCommand(explode1, 'fire.explodeVehicle()') 
  helper.queueLuaCommand(explode2, 'fire.explodeVehicle()')
  
  elseif luaTrigger == 'trigger2' and not highSpeedB then
    helper.flashUiMessage("Your running late! Speed up to 50mph(81kmh)!", 7)
    highSpeedB = true

  elseif luaTrigger == 'trigger8' and not trigger8 then
	trigger8 = true
    helper.flashUiMessage("DO NOT go over 35mph(56kmh) while off road!", 4)

  elseif luaTrigger == 'trigger3' and not madeIt then
    helper.queueLuaCommand(vehicle, 'fire.explodeVehicle()')
    scenario_scenarios.finish({failed = "You did not reach 50mph(81kmh)! You wont make it to the harbor!"})

  elseif luaTrigger == 'trigger1' and not highSpeedA then
    helper.flashUiMessage("Maintain 28mph(45kmh)!", 4)
    highSpeedA = true

  elseif luaTrigger == 'trigger4' and not highSpeedC  then
    helper.flashUiMessage("Almost there! Speed up to 50mph(81kmh)!", 5)
    highSpeedC = true
    madeIt = false

  elseif luaTrigger == 'trigger5' and not madeIt then
    helper.queueLuaCommand(vehicle, 'fire.explodeVehicle()')
    scenario_scenarios.finish({failed = "You did not reach 50mph(81kmh)! You wont make it to the harbor!"})

  elseif luaTrigger == 'trigger6' and not highSpeedB then
    helper.flashUiMessage("Your running late! Speed up to 50mph(81kmh)!", 7)
    highSpeedB = true
    madeIt = false

  elseif luaTrigger == 'trigger7' and not madeIt then
    helper.queueLuaCommand(vehicle, 'fire.explodeVehicle()')
    scenario_scenarios.finish({failed = "You did not reach 50mph(81kmh)! You wont make it to the harbor!"})
  end

end


local function onRaceWaypoint(data, goal)
  local wayPoint = data.waypointName

  if wayPoint == 'wp3' then
    slowSpeed = true

  elseif wayPoint == 'wp4' then
    slowSpeed = false
    helper.flashUiMessage("You are running late! Speed up and maintain 35mph(56kmh)!", 7)

  elseif wayPoint == 'wp5a' then
    highSpeedA = false
    helper.flashUiMessage("You're on time now! You can slow down!", 5)
  end

end


local function onRaceTick(raceTickTime)
  getVehicleSpeed()
  if slowSpeed then
    -- 15 35mph(56kmh)
    if getVehicleSpeed() > 14.9 then
      helper.queueLuaCommand(vehicle, 'fire.explodeVehicle()')
      scenario_scenarios.finish({failed = "You're driving over 35mph(56kmh) while off road!. The boss is not happy!"})
    end

  elseif highSpeedA then
    -- 15 35mph(56kmh)
    if getVehicleSpeed() < 11.85 then --28mph

      helper.queueLuaCommand(vehicle, 'fire.explodeVehicle()')
      scenario_scenarios.finish({failed = "You did not maintain 31mph(50kmh)! You wont make it to the harbor!."})
    end
  end

  if highSpeedB then
    -- 25 50mph(81kmh)
    if getVehicleSpeed() >= 21.1 then
      highSpeedB = false
      madeIt = true
      helper.flashUiMessage("You reached 50mph(81kmh)! You can slow down!", 5)
    end
  elseif highSpeedC then
    -- 20.9 50mph(81kmh)  19.7 46mph
    if getVehicleSpeed() >= 21.1 then
      highSpeedC = false
      madeIt = true
      helper.flashUiMessage("You reached 50mph(81kmh)! Maintain 35mph(56kmh)!", 5)
    end
  end

end


BEAMNG.onBeamNGTrigger = onBeamNGTrigger
BEAMNG.onRaceTick = onRaceTick
BEAMNG.onRaceWaypoint = onRaceWaypoint
BEAMNG.onRaceStart = onRaceStart

return BEAMNG